#define _CRT_SECURE_NO_WARNINGS
#define EPM_HANDLER_COMMON

#include <tccore/item.h>
#include <tccore/grmtype.h>
#include <tccore/grm.h>
#include <sa/am.h>
#include <tccore/aom.h>
#include <tccore/aom_prop.h>
#include <property/prop_errors.h>
#include <tccore/tctype.h>
#include <res/res_itk.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <vector>
#include "mdbks_register.h"
#include <chrono>
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
#include <sstream>
#include <tc\preferences.h>
#include <fstream>
#include <filesystem>
#include <windows.h>
#include <direct.h>
#include <io.h>
#include <codecvt>
#include "ae/dataset.h"
#include <iostream> 
#include <chrono> 
#include <iomanip> 
#include <sstream>
#include <tccore\releasestatus.h>

using namespace std;

std::string getCurrentDateAsString() { 
	auto now = std::chrono::system_clock::now(); 
	std::time_t current_time = std::chrono::system_clock::to_time_t(now);
	std::stringstream ss; 
	ss << std::put_time(std::localtime(&current_time), "%Y-%m-%d");
	return ss.str(); 
}

char* remove_suffix(char* file) {
	char* last_dot = strrchr(file, '.');
	if (last_dot != NULL && strrchr(file, '\\') < last_dot)
		*last_dot = '\0';
	return file;
}

//ݼ
int import_dataset_file_binary(tag_t dataset, const char* temp_path, const char* ref_name, char* ext, char* fullfilename, char* original_name)
{
	int ifail = ITK_ok;
	tag_t new_file_tag = NULLTAG;
	IMF_file_t file_descriptor = NULL;
	AOM_refresh(dataset, FALSE);
	char* new_file_name = NULL;
	char new_ds_name[WSO_name_size_c + 1] = "";
	char* filename = NULL;
	new_file_name = USER_new_file_name(new_ds_name, ref_name, ext, 0);
	filename = strrchr(fullfilename, '\\') + 1;
	if (filename == NULL)
		return ITK_ok;
	ITKCALL(ifail = IMF_import_file(fullfilename, new_file_name, SS_BINARY, &new_file_tag, &file_descriptor));
	ITKCALL(ifail = IMF_set_original_file_name2(new_file_tag, original_name));

	ITKCALL(ifail = IMF_close_file(file_descriptor));
	ITKCALL(ifail = AOM_save(new_file_tag));
	AOM_unlock(new_file_tag);
	ITKCALL(ifail = AOM_refresh(new_file_tag, FALSE));
	//
	ITKCALL(ifail = AOM_lock(dataset));
	if (ifail != ITK_ok) { return ifail; }
	ITKCALL(ifail = RES_checkout2(dataset, "import file", NULL, temp_path, RES_EXCLUSIVE_RESERVE));
	if (ifail != ITK_ok) { return ifail; }
	ITKCALL(ifail = AE_remove_dataset_named_ref2(dataset, ref_name));
	if (ifail != ITK_ok) { return ifail; }
	ITKCALL(ifail = AOM_save(dataset));
	ITKCALL(ifail = AE_add_dataset_named_ref2(dataset, ref_name, AE_PART_OF, new_file_tag));
	AOM_save(dataset);
	ITKCALL(ifail = RES_checkin(dataset));
	AOM_unlock(dataset);
	//ITKCALL( AOM_refresh( dataset, FALSE ) );
	return ifail;
}

char* removeFileExtension(char* datasetName) {
	std::string str(datasetName); 
	//  char* תΪ std::string 
	// һŵλ 
	size_t lastDotPos = str.find_last_of('.'); 
	// ҵ˵ 
	if (lastDotPos != std::string::npos) { 
		// ȡӿʼ֮ǰַ 
		str = str.substr(0, lastDotPos);
		// ת 
		char* datasetName = const_cast<char*>(str.c_str()); 
		return datasetName;
	} 
	return datasetName;
}

/**
 *
 * @HandlerName: Aks_ReleasePending
 * @HandlerType: ActionHandler
 * @Description: ִ֧handlerʱϵͳԶĿеĶ汾¹ݵPDFļмӸܿ£µPDFܿļܿ״̬¹ݵĶ汾
 * @author: hcj
 * @date: 202474
 *
 */
int Aks_ReleasePending(EPM_action_message_t msg) {
	//ȡ
	tag_t rootTask = NULLTAG;
	EPM_ask_root_task(msg.task, &rootTask);
	//ļкļǷ 򴴽
	const char* directory_path = "E:\\log";
	const char* file_path = "E:\\log\\Aks_ReleasePending.log";
	CreateDirectoryAndFile(directory_path, file_path);

	//־ļΪ׷ģʽ
	auto logFile = std::make_unique<std::ofstream>("E:\\log\\Aks_ReleasePending.log", std::ios::app);
	logFile->is_open();

	//ȡǰʱ
	auto now = std::chrono::system_clock::now();
	std::time_t time1 = std::chrono::system_clock::to_time_t(now);
	std::string timeStr = std::ctime(&time1);
	*logFile << "[" << timeStr.substr(0, timeStr.size() - 1) << "] ";
	*logFile << "=========================Aks_ReleasePending===================" << std::endl;
	int arg_cnt = 0, ifail = 0;
	char type[1024] = "";
	char isCheck[1024] = "";
	char relationType[1024] = "";
	char isDebug[1024] = "";
	char* argflag = NULL, * argvalue = NULL, * arg = NULL;
	//ȡhandlerĲĸ
	arg_cnt = TC_number_of_arguments(msg.arguments);
	*logFile << "ʼȡ̲Ϊ" << arg_cnt << std::endl;
	if (arg_cnt > 0)
	{
		for (int i = 0; i < arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "type") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(type, argvalue);
					*logFile << "type:" << type << std::endl;
				}
			}
			if (stricmp(argflag, "no_pdf_check") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(isCheck, argvalue);
					*logFile << "isCheck:" << isCheck << std::endl;
				}
			}if (stricmp(argflag, "relation_type") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(relationType, argvalue);
					*logFile << "relationType:" << relationType << std::endl;
				}
			}if (stricmp(argflag, "debug") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(isDebug, argvalue);
					*logFile << "isDebug:" << isDebug << std::endl;
				}
			}
		}
		MEM_free(argflag);
		MEM_free(argvalue);
	}

	*logFile << "-no_pdf_check	òãǱҪ޴˲Ŀ¶ݰ汾ǷPDFд˲ֵΪtrueʱ飻ֵΪfalseʱ顣" << std::endl;
	//-no_pdf_check	òãǱҪ޴˲Ŀ¶ݰ汾ǷPDFд˲ֵΪtrueʱ飻ֵΪfalseʱ顣
	if (strlen(isCheck)==0) 
	{
		strcpy(isCheck, "true");
	}
	bool Debug = false;
	 if (strcmp(isDebug,"true") == 0 || strcmp(isDebug, "TRUE") == 0)
	{
		Debug = true;
		*logFile << "ûã̲ʼ¼־" << std::endl;
	}
	else {
		*logFile << "ûã̲¼־־˳........................" << std::endl;
	}
	if(Debug)
		*logFile << "ȡѡ" << std::endl;
	int refCount = 0;
	char** refData;
	ITKCALL(PREF_ask_char_values("Aks_PDF_Stamp", &refCount, &refData));

	if (refCount == 0) {
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡAks_PDF_StampδûΪա");
		return -1;
	}
	if (Debug)
		*logFile << "ĿееĶжǷ[type]жĶͣĶܽһ" << std::endl;
	int att_cnt = 0;
	tag_t* attachments = NULL;
	ifail = EPM_ask_attachments(rootTask, EPM_target_attachment, &att_cnt, &attachments);
	for (int i = 0; i < att_cnt; i++) 
	{
		char* object_TYPE_1 = NULL;
		char* object_id;
		ifail = AOM_ask_value_string(attachments[i], "object_type", &object_TYPE_1);//
		if (Debug)
			*logFile << "ǰͶΪ" << object_TYPE_1 << std::endl;
		if (strcmp(object_TYPE_1,type) == 0) {
			ifail = AOM_ask_value_string(attachments[i], "item_id", &object_id);//ID
			if (Debug)
				*logFile << "ʼǷPDF" << std::endl;
			int relationCount = 0;
			tag_t* relationTag = NULLTAG;
			ifail = AOM_ask_value_tags(attachments[i], relationType, &relationCount, &relationTag);
			bool flag = true;
			for (int a = 0; a < relationCount; a++)
			{
				char* dataset_type;
				ITKCALL(AOM_ask_value_string(relationTag[a], "object_type", &dataset_type));
				if (strcmp(dataset_type, "PDF") == 0)
				{
					char* dataset_name1;
					char* dataset_name;
					ITKCALL(AOM_ask_value_string(relationTag[a], "object_name", &dataset_name1));
					vector<string> ans;
					Split(dataset_name1, ".", ans);
					if (ans.size()>1) {
						dataset_name = (char*)ans[0].c_str();
					}
					else {
						dataset_name = dataset_name1;
					}
					flag = false;
					if (Debug)
						*logFile << "ʼѡֵ" << std::endl;
					for (int b = 0; b < refCount; b++)
					{
						char* config = refData[b];
						vector<string> ans;
						Split(config, "=", ans);
						if (ans.size() != 2) 
						{
							EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡAks_PDF_Stamp");
							return -1;
						}
						if (Debug)
							*logFile << "ж" << std::endl;
						if (strcmp(object_TYPE_1,ans[0].c_str())==0) 
						{
							if (Debug)
								*logFile << "#ٴηָ" << std::endl;
							vector<string> pdfcount;
							Split(ans[1], "#", pdfcount);
							if (pdfcount.size() != 6) {
								EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡAks_PDF_Stamp");
								return -1;
							}
							if (pdfcount[0] != "null" && pdfcount[0] != "NULL")
							{
								if (Debug)
									*logFile << "ж״̬" << std::endl;
								int isra_cou = 0;
								tag_t* isra_tags;
								ITKCALL(AOM_ask_value_tags(attachments[i], "release_status_list", &isra_cou, &isra_tags));//жǷ񷢲
								char* object_type_release = NULL;
								logical develop = true;
								for (int f = 0; f < isra_cou; f++) 
								{
									AOM_ask_value_string(isra_tags[f], "object_name", &object_type_release);
									if (strcmp(object_type_release, pdfcount[0].c_str()) == 0) {
										develop = false;
										break;
									}
								}
								if (develop) {
									continue;
								}
							}
							if (Debug)
								*logFile << "ȡ汾" << std::endl;
							char* revision;
							AOM_ask_value_string(attachments[i], "item_revision_id", &revision);//
							if (Debug)
								*logFile << revision << std::endl;

							if (Debug)
								*logFile << "ȡ" << std::endl;
							tag_t  form_tag = NULLTAG;
							ITK__convert_uid_to_tag(pdfcount[1].c_str(), &form_tag);
							if (form_tag == NULLTAG) {
								string err = "PUID" + pdfcount[1] + "תΪ";
								EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, err.c_str());
								return -1;
							}
							if (Debug)
								*logFile << "»ȡϣʼȡݼļַ" << std::endl;
							tag_t ref_object = NULLTAG;
							AE_reference_type_t reference_type;
							char ref_name[WSO_name_size_c + 1] = "Image";
							AE_ask_dataset_named_ref2(form_tag, ref_name, &reference_type, &ref_object);
							if (reference_type == AE_PART_OF)
							{
								char* pathname;
								IMF_ask_file_pathname2(ref_object, SS_WNT_MACHINE, &pathname);
								char* origin_file_name;
								IMF_ask_original_file_name2(ref_object, &origin_file_name);
								char new_ds_name[WSO_name_size_c + 1] = "";
								char* new_file_name = USER_new_file_name(new_ds_name, ref_name, "png", 0);
								char* temp_dir = getenv("temp");
								char temp_file[SS_MAXPATHLEN] = "";
								strcpy(temp_file, temp_dir);
								strcat(temp_file, "\\");
								strcat(temp_file, new_file_name);
								IMF_export_file(ref_object, temp_file);
								if (Debug)
									*logFile << temp_file << std::endl;

								if (Debug)
									*logFile << "ȡpdfļ·" << std::endl;
								char pdf_ref_name[WSO_name_size_c + 1] = "PDF_Reference";
								AE_ask_dataset_named_ref2(relationTag[a], pdf_ref_name, &reference_type, &ref_object);
								if (reference_type == AE_PART_OF)
								{
									IMF_ask_file_pathname2(ref_object, SS_WNT_MACHINE, &pathname);
									IMF_ask_original_file_name2(ref_object, &origin_file_name);

									char new_ds_name2[WSO_name_size_c + 1] = "";
									char* new_file_name2 = USER_new_file_name(new_ds_name2, ref_name, "pdf", 0);
									char* temp_dir2 = getenv("temp");
									char temp_file2[SS_MAXPATHLEN] = "";
									char newtemp_file[SS_MAXPATHLEN] = "";
									strcpy(temp_file2, temp_dir2);
									strcpy(newtemp_file, temp_dir2);
									strcat(temp_file2, "\\");
									strcat(newtemp_file, "\\");
									strcat(temp_file2, new_file_name2);
									IMF_export_file(ref_object, temp_file2);
									if (Debug)
										*logFile << temp_file2 << std::endl;


									//µļ·
									std::string todayDate = getCurrentDateAsString();
									strcat(newtemp_file, dataset_name);
									strcat(newtemp_file, "_");
									strcat(newtemp_file, revision);
									strcat(newtemp_file, "_");
									strcat(newtemp_file, todayDate.c_str());
									strcat(newtemp_file, ".pdf");
									if (Debug)
										*logFile << "µļ·" << newtemp_file << std::endl;


									char newName[2048] = "";
									strcat(newName, dataset_name);
									strcat(newName, "_");
									strcat(newName, revision);
									strcat(newName, "_");
									strcat(newName, todayDate.c_str());
									if (Debug)
										*logFile << "ļƣ" << newName << std::endl;

									if (Debug)
										*logFile << "jar ʼǩ֣ʼִcmd" << std::endl;
									char cmd[4096] = "";
									strcpy(cmd, "java -jar E:\\Siemens\\Teamcenter14\\bin\\ASKPDF.jar");
									strcat(cmd, " \"");
									//pdf·
									strcat(cmd, temp_file2);
									strcat(cmd, "\"");
									strcat(cmd, " \"");
									//ǩ·
									strcat(cmd, temp_file);
									strcat(cmd, "\"");
									strcat(cmd, " \"");
									//С
									strcat(cmd, pdfcount[2].c_str());
									strcat(cmd, "\"");
									strcat(cmd, " \"");
									//תǶ
									strcat(cmd, pdfcount[3].c_str());
									strcat(cmd, "\"");
									strcat(cmd, " \"");
									//ͼƬ͸
									strcat(cmd, pdfcount[4].c_str());
									strcat(cmd, "\"");
									strcat(cmd, " \"");
									//͸
									strcat(cmd, pdfcount[5].c_str());
									//ļַ
									strcat(cmd, "\"");
									strcat(cmd, " \"");
									strcat(cmd, newtemp_file);
									strcat(cmd, "\"");
									if (Debug)
										*logFile << "cmd" << cmd << std::endl;
									system(cmd);
									if (Debug)
										*logFile <<"cmdִ" << std::endl;

									//ݼļ
									tag_t* word_tags = NULLTAG;
									int word_num = NULL;
									ITKCALL(AOM_ask_value_tags(attachments[i], "IMAN_Rendering", &word_num, &word_tags));
									tag_t pdf = NULLTAG;
									for (int n = 0; n < word_num; n++) {
										char* type = "";
										char* pdfname = "";
										ITKCALL(AOM_ask_value_string(word_tags[n], "object_type", &type));
										string newtype = Utf8ToGbk(type);
										type = (char*)newtype.data();
										if (Debug)
											*logFile <<"typeֵΪ%s:"<< type << std::endl;

										ITKCALL(AOM_ask_value_string(word_tags[n], "object_name", &pdfname));
										char* name1 = NULL;
										char* name2 = NULL;
										name1 = remove_suffix(pdfname);
										name2 = remove_suffix(newName);
										if (strcmp(type, "PDF") == 0 && strcmp(name1, name2) == 0) {
											pdf = word_tags[n];
											break;
										}
									}
									if (pdf == NULLTAG) {
										int rfCount;
										tag_t pdfTypeTag = NULLTAG, tool = NULLTAG, relationTag, * rfTags, newrelation;

										ITKCALL(AE_find_datasettype2("PDF", &pdfTypeTag));
										ITKCALL(AE_create_dataset_with_id(pdfTypeTag, newName, "", "", "A", &pdf));
										ITKCALL(AE_ask_datasettype_def_tool(pdfTypeTag, &tool));
										ITKCALL(AE_set_dataset_tool(pdf, tool));
										ITKCALL(AE_set_dataset_format2(pdf, "PDF_Reference"));
										ITKCALL(AOM_save(pdf));
										if (pdf == NULLTAG) {
											if (Debug)
												*logFile <<"ʧ\n" << std::endl;
										}
										else {
											if (Debug)
												*logFile <<"ɹ\n" << std::endl;
											ITKCALL(GRM_find_relation_type("IMAN_Rendering", &relationTag));
											if (relationTag == NULLTAG) {
												if (Debug)
													*logFile <<"1111111111111111111111111111111" << std::endl;
											}
											ITKCALL(GRM_list_secondary_objects_only(attachments[i], relationTag, &rfCount, &rfTags));
											ITKCALL(GRM_create_relation(attachments[i], pdf, relationTag, NULLTAG, &newrelation));
											ITKCALL(GRM_save_relation(newrelation));
											ITKCALL(AOM_unload(attachments[i]));
											ITKCALL(AOM_refresh(attachments[i], true));
										}
									}

									if (pdf != NULL) {
										if (Debug)
											*logFile <<"ѾPDFݼʼд"<< dataset_name << std::endl;
										ITKCALL(import_dataset_file_binary(pdf, "/tmp/", "PDF_Reference", "pdf", newtemp_file, strcat(newName, ".pdf")));
										//2019.11.27ٷ
										int temp_count = 1;
										tag_t* release_objs = NULL;
										tag_t release_status = NULLTAG;
										release_objs = (tag_t*)MEM_alloc(temp_count * sizeof(tag_t));
										release_objs[0] = pdf;

										ITKCALL(ifail = RELSTAT_create_release_status("TCM Released", &release_status));
										ITKCALL(ifail = RELSTAT_add_release_status(release_status, temp_count, release_objs, TRUE));

										POM_AM__set_application_bypass(false);
										if (release_objs != NULL)
										{
											MEM_free(release_objs);
											release_objs = NULL;
										}
									}
									else {
										if (Debug)
											*logFile <<"ǰ汾ûIMAN_Renderingļ" << std::endl;
									}

								}
							}
						}
					}
				}
			}
			if (flag && (strcmp(isCheck,"true")==0 || strcmp(isCheck, "TRUE") == 0)) {
				string id = object_id;
				string err = "" + id + "ָϵδҵPDF";
				EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, err.c_str());
				return -1;
			}
		}
	}
	return ITK_ok;
}